#include <QCoreApplication>
#include <QLocalServer>
#include <QLocalSocket>
#include <QProcess>
#include <QTimer>

int main(int argc, char *argv[])
{
    QCoreApplication app(argc, argv);

    if (!app.arguments().contains("-s")){
        QLocalServer s;
        s.listen("foo");
        QObject::connect(&s, &QLocalServer::newConnection,[&s]{
            auto o = s.nextPendingConnection();
            QObject::connect(o, &QLocalSocket::disconnected,[]{
                qDebug("disconnected");
                QTimer::singleShot(200, []{
                    qApp->quit();
                });
            });
            QObject::connect(o, &QLocalSocket::readyRead,[o]{
                qDebug() << "readyRead";
            });
        });

        QProcess p;
        p.setProgram(argv[0]);
        p.setArguments(QStringList()<<"-s");
        p.startDetached();
        return app.exec();
    }
    else{
        QLocalSocket c;
        QObject::connect(&c, &QLocalSocket::connected,[&c]{
            c.write(QByteArray(1024*1024*64, 'a'));
            c.flush();
            exit(0);
        });
        c.connectToServer("foo");
        return app.exec();
    }
}
